import React from 'react';
import axios from 'axios'
import JSEncrypt from 'JSEncrypt'
import { message ,Modal} from 'antd'
import utils from './utils/utils';
const { confirm } = Modal;
const LOGIN_URL = 'https://accounts.pixiv.net/login?lang=zh&source=pc&view_type=page&ref=wwwtop_accounts_index';
const USER_AGENT = 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36';
const LOGIN_API = 'https://accounts.pixiv.net/api/login?lang=zh';

  
const axiosService = axios.create();

axiosService.defaults.timeout = 500000;

axiosService.defaults.headers.common['X-Requested-With'] = 'XMLHttpRequest';

axiosService.interceptors.request.use(
  (config) => {
    if (config.data && config.data.$skipAuthHandler) {
      config.$skipAuthHandler = true;
      delete config.data.$skipAuthHandler;
    }
    if (config.params && config.params.$skipAuthHandler) {
      config.$skipAuthHandler = true;
      delete config.params.$skipAuthHandler;
    }

    return config;
  },
  (error) => {
    return Promise.reject(error)
  }
);

axiosService.interceptors.response.use(
  (response) => {
    return response;
  },
  (error) => {
    if (error && error.stack.indexOf('timeout') > -1) {
      message.destroy();
      message.error('请求超时,请重新登录！', 2);
    }
    const err = error.response;

    if (err.status === 401 && !!err.config && !err.config.$skipAuthHandler) {
      //_loginUser.clear();
      window.location = '/admin/401';
      // message.error('有接口401', 2);
      window.sessionStorage.removeItem('userFlag');
      window.sessionStorage.removeItem('token');
    } else if (err.status === 404 && !!err.config && !err.config.$skipAuthHandler) {
      window.location = '/admin/404';
    } else if (err.status === 500 && !!err.config && !err.config.$skipAuthHandler) {
      window.location = '/admin/500';
      message.error('有接口500', 2);
    } else if (err.status === 504 && !!err.config && !err.config.$skipAuthHandler) {
      message.destroy();
      message.error('请求超时,请重新登录！', 2);
    } else {
      message.error('请求超时,请重新登录！', 2);
    }

    return Promise.reject(error);
  }
);
export default{
   ajaxApi  (baseUrl = '', url = '', method = 'GET', params = {}, config = {}) {
    console.log(baseUrl,url)
    
      const apiToken =   window.sessionStorage.getItem('token')?window.sessionStorage.getItem('token'):"";
      const apiUserFlag =   window.sessionStorage.getItem('userFlag')?window.sessionStorage.getItem('userFlag'):"";
      let time=String(new Date().getTime())
      const data = (method === 'GET') ? 'params' : 'data';
      let headers = {
        'X-Requested-With': 'XMLHttpRequest',
        'Content-Type': 'application/json',
        'Authorization': apiToken,
        'token': apiToken,
        "userFlag": apiUserFlag,
        'timestamp':new Date().getTime(),
         'sign':apiToken?utils.encrypt(apiUserFlag+apiToken+time):utils.encrypt(time)
    
      };
      if (config.headers) {
        headers = {
          ...headers,
          ...config.headers
        }
      }
      return new Promise((resolve, reject) => {
        axiosService({
          url: url,
          method: method,
          baseURL: baseUrl,
          [data]: params,
          headers,
        }).then((response) => {
    
        
            let res = response.data;
    
            if (res.success === true) {
    
              resolve(res)
            } else if (res.success === false) {
              if(res.code!=100001){
                reject(response);
                if (document.getElementsByClassName('haha12').length === 0) {
                  let confimModal= confirm({
                    title: res.msg,
                    okText: "是",
                    okType: "primary",
                    className: 'haha12',
                    cancelText: "否",
                    onOk: () => {
                      confimModal.destroy()
                    },
                   
                  })
                }
              }else{
                resolve(res);
              }
              // message.error(typeof res.msg === 'string' ? res.msg : JSON.stringify(res.msg));
        
            }
       
        })
          .catch(error => {
            console.log(error.response);
            reject(error);
            //   if(error.response&&error.response.data&&error.response.data.msg){
            //     message.error(typeof error.response.data === 'string' ? error.response.data.msg : JSON.stringify(error.response.data.msg));
            //   }
    
    
          });
      })
    
    
    },
   ajaxLogin (baseUrl = '', url = '', method = 'GET', params = {}, config = {}) {
    console.log(baseUrl,url)
    
     
      let time=String(new Date().getTime())
      const data = (method === 'GET') ? 'params' : 'data';
      let headers = {
        'X-Requested-With': 'XMLHttpRequest',
        'Content-Type': 'application/json',
        'Authorization': '',
        'token': '',
        "userFlag": '',
        'timestamp':new Date().getTime(),
         'sign':utils.encrypt(time)
    
      };
      if (config.headers) {
        headers = {
          ...headers,
          ...config.headers
        }
      }
      return new Promise((resolve, reject) => {
        axios({
          url: url,
          method: method,
          baseURL: baseUrl,
          [data]: params,
          headers,
        }).then((response) => {
    
        
            let res = response.data;
    
            if (res.success === true) {
    
              resolve(res)
            } else if (res.success === false) {
              if(res.code!=100001){
                reject(response);
                if (document.getElementsByClassName('haha12').length === 0) {
                  let confimModal= confirm({
                    title: res.msg,
                    okText: "是",
                    okType: "primary",
                    className: 'haha12',
                    cancelText: "否",
                    onOk: () => {
                      confimModal.destroy()
                    },
                   
                  })
                }
              }else{
                resolve(res);
              }
              // message.error(typeof res.msg === 'string' ? res.msg : JSON.stringify(res.msg));
        
            }
       
        })
          .catch(error => {
            console.log(error.response);
            reject(error);
            //   if(error.response&&error.response.data&&error.response.data.msg){
            //     message.error(typeof error.response.data === 'string' ? error.response.data.msg : JSON.stringify(error.response.data.msg));
            //   }
    
    
          });
      })
    
    
    }
}



